# -*- coding: utf-8 -*-
from __future__ import print_function
import math, os, sys, random
from simanneal import Annealer

path=sys.argv[1]
files=list(os.walk(path))[0][2]

# 3rd element of tuple: number of steps
# increase for better results. will work slower, though.
tests=[
        ("gzip --fast", "gz", 2000),
        ("gzip --best", "gz", 2000),
        ("bzip2 --fast", "bz2", 2000),
        ("bzip2 --best", "bz2", 2000),
        ("xz -z --fast", "xz", 2000),
        ("xz -z --best", "xz", 2000)
]

def get_size_of_archive(state, min_or_max, test):
    cmdline="tar cf tmp.tar "
    for f in state:
        cmdline=cmdline+path+"/'"+f+"' "
    os.system(cmdline)

    compressed_fname="tmp.tar."+test[1]
    os.system (test[0]+" tmp.tar")
    fsize=os.path.getsize(compressed_fname)
    if min_or_max==False:
        rt=fsize
    else:
        rt=-fsize
    os.system ("rm "+compressed_fname)

    return rt

class FindPermutation(Annealer):

    def __init__(self, state, min_or_max, compressor):
        self.min_or_max=min_or_max
        self.test=test
        super(FindPermutation, self).__init__(state)  # important!

    def move(self):
        initial_energy = self.energy()

        a = random.randint(0, len(self.state) - 1)
        b = random.randint(0, len(self.state) - 1)
        self.state[a], self.state[b] = self.state[b], self.state[a]

        return self.energy() - initial_energy

    def energy(self):
        return get_size_of_archive(self.state, self.min_or_max, self.test)

def process (min_or_max, test):

    # initial state is random
    init_state = files
    random.shuffle(init_state)

    tmp = FindPermutation(init_state, min_or_max, test)
    tmp.steps=test[2]
    tmp.copy_strategy = "slice"
    state, e = tmp.anneal()

    print (state)
    print ("size:", abs(e))
    return abs(e) 

for test in tests:
    print ("Command:", test[0])
    print ("Minimizing...")
    _min=process(False, test)
    print ("Maximizing...")
    _max=process(True, test)

    print ("Delta=", _max-_min)

